﻿using Microsoft.Identity.Client;
using Syncfusion.XlsIO;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Configuration;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace F150848
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private async void button1_Click(object sender, EventArgs e)
        {
            PublicClientApplication clientApp = new PublicClientApplication(ConfigurationManager.AppSettings["clientId"].ToString());
            Microsoft.Graph.GraphServiceClient graphClient = new Microsoft.Graph.GraphServiceClient("https://graph.microsoft.com/v1.0", new Microsoft.Graph.DelegateAuthenticationProvider(async (requestMessage) => {
                requestMessage.Headers.Authorization = new AuthenticationHeaderValue("bearer", await GetTokenAsync(clientApp));
            }));
            try
            {
                //Initialize ExcelEngine
                ExcelEngine excelEngine = new ExcelEngine();

                //Initialize IApplication
                IApplication application = excelEngine.Excel;

                //Enable fast record parsing
                application.UseFastRecordParsing = true;

                //Get the file from OneDrive into stream
                var stream = await graphClient.Me.Drive.Root.ItemWithPath("Sample.xlsx").Content.Request().GetAsync();

                //Set the stream position as '0'
                stream.Position = 0;

                //Initialize new MemoryStream and copy the existing stream to this new MemeoryStream
                MemoryStream file = new MemoryStream();
                stream.CopyTo(file);

                //Set the stream position as '0'
                file.Position = 0;

                //Load the stream into IWorkbook
                IWorkbook workbook = application.Workbooks.Open(file);

                //Modify the Excel document
                workbook.Worksheets[0].Range["A2"].Text = "Syncfusion Essential XlsIO";

                //Save the modified Excel document as new MemoryStream
                MemoryStream outputStream = new MemoryStream();
                workbook.SaveAs(outputStream);

                //Set the stream position as '0'
                outputStream.Position = 0;

                //Upload the modified Excel document to OneDrive again
                await graphClient.Me.Drive.Root.ItemWithPath("ModifiedFile2.xlsx").Content.Request().PutAsync<Microsoft.Graph.DriveItem>(outputStream);

                //Close the workbook
                workbook.Close();

                //Dispose the ExcelEngine
                excelEngine.Dispose();
            }

            catch (Microsoft.Graph.ServiceException ex)
            {
                Console.WriteLine(ex);
            }
        }
        async Task<string> GetTokenAsync(PublicClientApplication clientApp)
        {
            //need to pass scope of activity to get token  
            string[] Scopes = { "User.Read Files.ReadWrite Files.ReadWrite.All" };
            string token = null;
            AuthenticationResult authResult = await clientApp.AcquireTokenAsync(Scopes);
            token = authResult.AccessToken;
            return token;
        }
    }
}
